% function analysisCrossValidation
clear
t_95margin_df4 = 2.78;

%% Plotting the AUC comparisons

gain_thres = 0.1;

% run 1:5: 10 positive training examples
count = 1; 
auc10_oriHistLogLinear = zeros(1,5);
auc10_combined = zeros(1,5);
auc10_sketchLocalAdapt = zeros(1,5);
for iRun = 1:5
    load(sprintf('oriHistLogLinear/combinedWithSketchLocalAdapt_run%d.mat',iRun),'testAUC');
    auc10_combined(count) = testAUC;
    
    load(sprintf('oriHistLogLinear/out_run%d.mat',iRun),'testAUC');
    load(sprintf('oriHistLogLinear/model_run%d.mat',iRun),'gain');
    auc10_oriHistLogLinear(count) = testAUC(sum(gain>gain_thres));

    load(sprintf('sketchLocalAdapt/out_run%d.mat',iRun),'testAUC');
    load(sprintf('sketchLocalAdapt/model_run%d.mat',iRun),'gain');
    auc10_sketchLocalAdapt(count) = testAUC(sum(gain>gain_thres));

    count = count + 1;
end

% run 6~10: 20 positive training examples
count = 1; 
auc20_oriHistLogLinear = zeros(1,5);
auc20_combined = zeros(1,5);
auc20_sketchLocalAdapt = zeros(1,5);
for iRun = 6:10
    load(sprintf('oriHistLogLinear/combinedWithSketchLocalAdapt_run%d.mat',iRun),'testAUC');
    auc20_combined(count) = testAUC;
    
    load(sprintf('oriHistLogLinear/out_run%d.mat',iRun),'testAUC');
    load(sprintf('oriHistLogLinear/model_run%d.mat',iRun),'gain');
    auc20_oriHistLogLinear(count) = testAUC(sum(gain>gain_thres));

    load(sprintf('sketchLocalAdapt/out_run%d.mat',iRun),'testAUC');
    load(sprintf('sketchLocalAdapt/model_run%d.mat',iRun),'gain');
    auc20_sketchLocalAdapt(count) = testAUC(sum(gain>gain_thres));

    count = count + 1;
end

% run 11~15: 40 positive training examples
count = 1; 
auc40_oriHistLogLinear = zeros(1,5);
auc40_combined = zeros(1,5);
auc40_sketchLocalAdapt = zeros(1,5);
for iRun = 11:15
    load(sprintf('oriHistLogLinear/combinedWithSketchLocalAdapt_run%d.mat',iRun),'testAUC');
    auc40_combined(count) = testAUC;
    
    load(sprintf('oriHistLogLinear/out_run%d.mat',iRun),'testAUC');
    load(sprintf('oriHistLogLinear/model_run%d.mat',iRun),'gain');
    auc40_oriHistLogLinear(count) = testAUC(sum(gain>gain_thres));

    load(sprintf('sketchLocalAdapt/out_run%d.mat',iRun),'testAUC');
    load(sprintf('sketchLocalAdapt/model_run%d.mat',iRun),'gain');
    auc40_sketchLocalAdapt(count) = testAUC(sum(gain>gain_thres));

    count = count + 1;
end

% run 16~20: 80 positive training examples
count = 1; 
auc80_oriHistLogLinear = zeros(1,5);
auc80_combined = zeros(1,5);
auc80_sketchLocalAdapt = zeros(1,5);
for iRun = 16:20
    load(sprintf('oriHistLogLinear/combinedWithSketchLocalAdapt_run%d.mat',iRun),'testAUC');
    auc80_combined(count) = testAUC;
    
    load(sprintf('oriHistLogLinear/out_run%d.mat',iRun),'testAUC');
    load(sprintf('oriHistLogLinear/model_run%d.mat',iRun),'gain');
    auc80_oriHistLogLinear(count) = testAUC(sum(gain>gain_thres));

    load(sprintf('sketchLocalAdapt/out_run%d.mat',iRun),'testAUC');
    load(sprintf('sketchLocalAdapt/model_run%d.mat',iRun),'gain');
    auc80_sketchLocalAdapt(count) = testAUC(sum(gain>gain_thres));

    count = count + 1;
end

% run 21~25: 5 positive training examples
count = 1; 
auc5_oriHistLogLinear = zeros(1,5);
auc5_combined = zeros(1,5);
auc5_sketchLocalAdapt = zeros(1,5);
for iRun = 21:25
    load(sprintf('oriHistLogLinear/combinedWithSketchLocalAdapt_run%d.mat',iRun),'testAUC');
    auc5_combined(count) = testAUC;
    
    load(sprintf('oriHistLogLinear/out_run%d.mat',iRun),'testAUC');
    load(sprintf('oriHistLogLinear/model_run%d.mat',iRun),'gain');
    auc5_oriHistLogLinear(count) = testAUC(sum(gain>gain_thres));

    load(sprintf('sketchLocalAdapt/out_run%d.mat',iRun),'testAUC');
    load(sprintf('sketchLocalAdapt/model_run%d.mat',iRun),'gain');
    auc5_sketchLocalAdapt(count) = testAUC(sum(gain>gain_thres));

    count = count + 1;
end


curve1 = [mean(auc5_sketchLocalAdapt), mean(auc10_sketchLocalAdapt), mean(auc20_sketchLocalAdapt), mean(auc40_sketchLocalAdapt), mean(auc80_sketchLocalAdapt)];
err1 = [std(auc5_sketchLocalAdapt), std(auc10_sketchLocalAdapt), std(auc20_sketchLocalAdapt), std(auc40_sketchLocalAdapt), std(auc80_sketchLocalAdapt)];
curve2 = [mean(auc5_oriHistLogLinear), mean(auc10_oriHistLogLinear), mean(auc20_oriHistLogLinear), mean(auc40_oriHistLogLinear), mean(auc80_oriHistLogLinear)];
err2 = [std(auc5_oriHistLogLinear), std(auc10_oriHistLogLinear), std(auc20_oriHistLogLinear), std(auc40_oriHistLogLinear), std(auc80_oriHistLogLinear)];
curve3 = [mean(auc5_combined), mean(auc10_combined), mean(auc20_combined), mean(auc40_combined), mean(auc80_combined)];
err3 = [std(auc5_combined), std(auc10_combined), std(auc20_combined), std(auc40_combined), std(auc80_combined)];


% Plot the three curves of Test AUC
%   with 95% confidence bounds
figure;
hold on;
plot([5,10,20,40,80],curve1+t_95margin_df4*err1/sqrt(5),'k:','LineWidth',2);
h1 = plot([5,10,20,40,80],curve1,'k-s','LineWidth',3);
plot([5,10,20,40,80],curve1-t_95margin_df4*err1/sqrt(5),'k:','LineWidth',2);

plot([5,10,20,40,80],curve2+t_95margin_df4*err2/sqrt(5),'r:','LineWidth',2);
h2 = plot([5,10,20,40,80],curve2,'r-','LineWidth',3);
plot([5,10,20,40,80],curve2-t_95margin_df4*err2/sqrt(5),'r:','LineWidth',2);

plot([5,10,20,40,80],curve3+t_95margin_df4*err3/sqrt(5),'b:','LineWidth',2);
h3 = plot([5,10,20,40,80],curve3,'b-.','LineWidth',3);
plot([5,10,20,40,80],curve3-t_95margin_df4*err3/sqrt(5),'b:','LineWidth',2);


set(gca,'FontSize',12);
set(gca,'ylim',[0.95 1]);
set(get(gca,'XLabel'),'String','# training positives','FontSize',18);
set(get(gca,'YLabel'),'String','testing AUC','FontSize',18);
legend([h1 h2 h3],{'Sketch','Texture','Combined'},'Location','SouthEast','FontSize',20);
title('AUC vs. the number of positive training examples','FontSize',18);
set(gcf, 'PaperPositionMode', 'auto');
print -depsc auc_comparison.eps
print -dpng auc_comparison.png
plot2svg('auc_comparison.svg',gcf,'png');

