function tss = OHtest_compute(iRun,imagePaths)

load(sprintf('model_run%d.mat',iRun)); % load trained shared-sketch model

nimage = length(imagePaths); % # images

% FILTERING IMAGES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('start filtering');
tic
allfilter = makefilter(scale, norient);  % generate Gabor filters 
allfiltered = getS1Maps(imagePaths,templateSize,allfilter); % compute Sum1 maps
disp(['filtering time: ' num2str(toc) ' seconds']);

% sigmoid transformation
Ctransform(nimage, norient, allfiltered, templateSize(1)*ones(nimage,1), templateSize(2)*ones(nimage,1), Upperbound);

disp('start testing');
tic

% compute local mean features
localMeanMap = cell(nimage,norient);

% compute local mean maps using (the integral image) fft 
averageFilter = ones(2*ax+1,2*ax+1)/(2*ax+1)/(2*ax+1);
for i = 1:nimage
    imsize = size(allfiltered{i,1});
    ave = zeros(imsize);
    for o = 1:norient
        localMeanMap{i,o} = filter2(averageFilter,allfiltered{i,o},'same');
        ave = ave + 1/norient * localMeanMap{i,o};
    end
    for o = 1:norient
        localMeanMap{i,o} = localMeanMap{i,o} ./ ( ave + 1e-10 );
    end
end


clear allfiltered

tss = zeros(nimage, maxNumFeature);  % total scores for testing images
for i = 1:nimage
    for iF = 1:maxNumFeature % possible to have maxNumFeature > nF
        if iF > nF
            break;
        else
            r = localMeanMap{i,Mi(iF)}(Mx(iF),My(iF));
            tss(i,iF) = lambda(iF) * r - logZ(iF);
        end
    end
end

disp(['testing time: ' num2str(toc) ' seconds']);