function LearnAndTest

%
% Learning active basis models, and testing them with local adaptive Gabor responses.
%

% compile mex-C files
mex Clearn.c
mex Ctesting.c
mex Ctransform.c
mex Chistog.c

addpath('../');

ax = 10; % (unit: pixels) radius of neighborhood for local adaption

for iRun = 1:25 % randomized repitition runs
    disp(sprintf('run %d starts : ',iRun));
    tilt(iRun); 		% compute natural image statistics (from "negative" examples)
    ABlearn(iRun); 	% shared pursuit algorithm to learn an active basis template from positive training images
    ABtest(iRun,ax);	% testing the template for classification on testing positive and negative images
end
